/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  fire.pb.move.SSetRoleTeamInfo
 *  fire.pb.scene.Scene
 *  fire.pb.scene.manager.RoleManager
 *  mkio.Protocol
 */
package fire.pb.scene.movable;

import fire.pb.move.SSetRoleTeamInfo;
import fire.pb.scene.Scene;
import fire.pb.scene.manager.RoleManager;
import fire.pb.scene.movable.Role;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;
import java.util.Set;
import mkio.Protocol;

public class SceneTeam {
    private final long teamID;
    private Role capitan;
    private final List<Role> members = new ArrayList<Role>();
    private final Set<Role> leavers = new HashSet<Role>();
    private Map<Long, Long> hugs = new HashMap<Long, Long>();
    public static final int TEAM_NONE = 0;
    public static final int TEAM_NORMAL = 1;
    public static final int TEAM_APART = 2;
    public static final int TEAM_LEADER = 5;
    private static final int MAX_TEAMSIZE = 5;

    SceneTeam(long tid, long roleID) {
        this.teamID = tid;
        this.capitan = RoleManager.getInstance().getRoleByID(roleID);
        this.capitan.setTeam(this);
        this.capitan.setTeamIndex(1);
    }

    public long getTeamID() {
        return this.teamID;
    }

    public void sendTeamInfoToRole(Role sendrole) {
        SSetRoleTeamInfo snd = new SSetRoleTeamInfo();
        if (null == this.capitan) {
            return;
        }
        snd.roleid = this.capitan.getRoleID();
        snd.teamid = this.teamID;
        snd.teamindex = 1;
        snd.teamstate = 1;
        snd.teamnormalnum = this.getAllMemberIDs().size();
        sendrole.send((Protocol)snd);
        for (Role tm : this.members) {
            SSetRoleTeamInfo snd2 = new SSetRoleTeamInfo();
            snd2.roleid = tm.getRoleID();
            snd2.teamid = this.teamID;
            snd2.teamindex = tm.getTeamIndex();
            snd2.teamstate = 1;
            snd2.teamnormalnum = this.getAllMemberIDs().size();
            sendrole.send((Protocol)snd2);
        }
    }

    public void broadcastTeam() {
        SSetRoleTeamInfo snd2;
        SSetRoleTeamInfo snd = new SSetRoleTeamInfo();
        StringBuilder sb = new StringBuilder("sendTeamInfoOut : teamid = ").append(this.teamID);
        if (null == this.capitan) {
            return;
        }
        Scene rs = this.capitan.getScene();
        if (null == rs) {
            return;
        }
        this.capitan.marshal();
        snd.roleid = this.capitan.getRoleID();
        snd.teamid = this.teamID;
        snd.teamindex = 1;
        snd.teamstate = 1;
        snd.teamnormalnum = this.getAllMemberIDs().size();
        this.capitan.sendAround((Protocol)snd);
        for (Role tm : this.members) {
            tm.marshal();
            snd2 = new SSetRoleTeamInfo();
            snd2.roleid = tm.getRoleID();
            snd2.teamid = this.teamID;
            snd2.teamindex = tm.getTeamIndex();
            snd2.teamstate = 1;
            snd2.teamnormalnum = this.getAllMemberIDs().size();
            sb.append("; roleid = ").append(snd2.roleid).append(",index=").append(snd2.teamindex).append(",state=").append(snd2.teamstate);
            tm.sendAround((Protocol)snd2);
        }
        for (Role tl : this.leavers) {
            tl.marshal();
            snd2 = new SSetRoleTeamInfo();
            snd2.roleid = tl.getRoleID();
            snd2.teamid = this.teamID;
            snd2.teamindex = tl.getTeamIndex();
            snd2.teamstate = 2;
            snd2.teamnormalnum = this.getAllMemberIDs().size();
            sb.append("; roleid = ").append(snd2.roleid).append(",index=").append(snd2.teamindex).append(",state=").append(snd2.teamstate);
            tl.sendAround((Protocol)snd2);
        }
        Scene.LOG.debug((Object)sb.toString());
    }

    public int size() {
        return this.members.size() + 1;
    }

    public List<Role> getMembers() {
        return this.members;
    }

    public boolean canMove() {
        for (Role r : this.members) {
            if (r.checkCanMoveState()) continue;
            return false;
        }
        return true;
    }

    public Role getCapitan() {
        return this.capitan;
    }

    public long getCapitanRoleID() {
        return this.capitan.getUniqueID();
    }

    public Set<Role> getLeavers() {
        return this.leavers;
    }

    public void changeCapitan(Role newCap) {
        Role oldCap = this.capitan;
        int oi = newCap.getTeamIndex();
        if (oi == 1 || oi == 0) {
            return;
        }
        oldCap.setTeamIndex(oi);
        newCap.setTeamIndex(1);
        this.capitan = newCap;
        if (oi == -1) {
            this.leavers.remove(newCap);
            this.leavers.add(oldCap);
        } else if (oi >= 2) {
            this.members.set(oi - 2, oldCap);
        }
        if (oldCap.isJumping()) {
            oldCap.getJumpRole().confirmPositionToStart();
        }
    }

    public void joinAsMember(Role mem) {
        if (this.members.size() >= 4) {
            return;
        }
        if (this.members.contains(mem)) {
            Scene.LOG.error((Object)("添加正常队员时，已经存在了：" + mem));
            return;
        }
        mem.setTeam(this);
        this.onBackTeam(mem);
        mem.notifySeeTeammates();
    }

    public void leaveFromTeam(Role leaver) {
        leaver.setTeam(this);
        leaver.leaveFromTeam();
        this.leavers.add(leaver);
        if (!this.members.remove(leaver)) {
            leaver.notifySeeTeammates();
            return;
        }
        int i = 2;
        for (Role m : this.members) {
            m.setTeamIndex(i++);
        }
        leaver.notifyLeaverPosition();
        this.getCapitan().notifyLeaverPosition();
    }

    public void quitFromTeam(Role q) {
        q.quitFromTeam();
        if (this.leavers.remove(q)) {
            return;
        }
        this.members.remove(q);
        int i = 2;
        for (Role m : this.members) {
            m.setTeamIndex(i++);
        }
    }

    public void changeSeq(Role r1, Role r2) {
        int i1 = r1.getTeamIndex() - 2;
        int i2 = r2.getTeamIndex() - 2;
        this.members.set(i1, r2);
        this.members.set(i2, r1);
        r1.setTeamIndex(i2 + 2);
        r2.setTeamIndex(i1 + 2);
    }

    public void backToTeam(Role mem) {
        if (this.size() > 5) {
            return;
        }
        if (!this.leavers.remove(mem)) {
            Scene.LOG.error((Object)("暂离队员归队时，不存在：" + mem));
        }
        this.onBackTeam(mem);
    }

    public void destroy() {
        this.capitan.quitFromTeam();
        for (Role m : this.members) {
            m.quitFromTeam();
        }
        for (Role l : this.leavers) {
            l.quitFromTeam();
        }
        this.members.clear();
        this.leavers.clear();
    }

    private void onBackTeam(Role mem) {
        if (this.members.contains(mem)) {
            this.members.remove(mem);
        }
        this.members.add(mem);
        mem.setTeamIndex(this.size());
        mem.updatePosition(this.capitan.getPos());
    }

    Set<Long> getAllMemberIDs() {
        HashSet<Long> set = new HashSet<Long>();
        set.add(this.capitan.getRoleID());
        for (Role r : this.members) {
            set.add(r.getRoleID());
        }
        if (set.size() != this.members.size() + 1) {
            Scene.LOG.error((Object)("队伍的正常队员有重复 : " + this.members.toString()));
        }
        return set;
    }

    Set<Long> getMemberIDs() {
        HashSet<Long> set = new HashSet<Long>();
        for (Role r : this.members) {
            set.add(r.getRoleID());
        }
        return set;
    }

    Set<Long> getLeaverIDs() {
        HashSet<Long> set = new HashSet<Long>();
        for (Role r : this.leavers) {
            set.add(r.getRoleID());
        }
        return set;
    }

    public byte getHugIndex(long roleId) {
        if (this.hugs == null || this.hugs.isEmpty()) {
            return 0;
        }
        LinkedList<Long> normalrids = new LinkedList<Long>();
        normalrids.add(this.capitan.getRoleID());
        for (Role mem : this.getMembers()) {
            normalrids.add(mem.getRoleID());
        }
        if (!normalrids.contains(roleId)) {
            return 0;
        }
        Iterator<Map.Entry<Long, Long>> it = this.hugs.entrySet().iterator();
        while (it.hasNext()) {
            Map.Entry<Long, Long> entry = it.next();
            if (!normalrids.contains(entry.getKey()) || !normalrids.contains(entry.getValue())) {
                it.remove();
                continue;
            }
            if (entry.getKey() == roleId) {
                int index = normalrids.indexOf((long)entry.getValue());
                if (index < 0) {
                    return 0;
                }
                return (byte)(index + 1);
            }
            if (entry.getValue() != roleId) continue;
            int index = normalrids.indexOf((long)entry.getKey());
            if (index < 0) {
                return 0;
            }
            return (byte)(index + 1);
        }
        return 0;
    }

    public List<Role> getAllTeammates() {
        LinkedList<Role> list = new LinkedList<Role>();
        list.add(this.getCapitan());
        list.addAll(this.getMembers());
        list.addAll(this.getLeavers());
        return list;
    }
}

